<?php
 
/**
 *
 *
 *   LDAP PHP Change Password Webpage
 *
 *   Adapted for FUSS by: Christopher R. Gabriel <cgabriel@truelite.it>
 *
 *   Based on work by:
 *
 *   @author:   Matt Rude <http://mattrude.com>
 *   @website:  http://technology.mattrude.com/2010/11/ldap-php-change-password-webpage/
 *
 *
 *              GNU GENERAL PUBLIC LICENSE
 *                 Version 2, June 1991
 *
 * Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * Everyone is permitted to copy and distribute verbatim copies
 * of this license document, but changing it is not allowed.
 */
 
$message = array();
$message_css = "";
 
function changePassword($user,$oldPassword,$newPassword,$newPasswordCnf){
  global $message;
  global $message_css;
 
  $server = "localhost";
  $dn = "ou=Users,{{ basedn }}";
    
  error_reporting(0);
  ldap_connect($server);
  $con = ldap_connect($server);
  ldap_set_option($con, LDAP_OPT_PROTOCOL_VERSION, 3);
   
  // bind anon and find user by uid
  $user_search = ldap_search($con,$dn,"(&(uid=$user)(ou=studenti))");
  $user_get = ldap_get_entries($con, $user_search);
  $user_entry = ldap_first_entry($con, $user_search);
  if ( $user_get["count"] == 0 ) {
      $user_research = ldap_search($con,$dn,"(uid=$user)");
      $user_reget = ldap_get_entries($con, $user_research);
      if ( $user_reget["count"] != 0 ) {
	  $message[] = "Errore E103 - Utente non autorizzato all'uso di questa interfaccia.";
	  return false;
      }
      $message[] = "Errore E100 - Utente inesistente.";
      return false;
  }
  $user_dn = ldap_get_dn($con, $user_entry);
  $user_id = $user_get[0]["uid"][0];
  $user_search_arry = array( "*", "ou", "uid");
  $user_search_filter = "(&(uid=$user_id)(ou=studenti))";
  $user_search_opt = ldap_search($con,$user_dn,$user_search_filter,$user_search_arry);
  $user_get_opt = ldap_get_entries($con, $user_search_opt);
   
  if (ldap_bind($con, $user_dn, $oldPassword) === false) {
    $message[] = "Errore E101 - Utente e password attuali non corretti.";
    return false;
  }
  if ($newPassword != $newPasswordCnf ) {
    $message[] = "Errore E102 - Le tue nuove password non sono uguali!";
    return false;
  }

  $encoded_newPassword = "{SHA}" . base64_encode( pack( "H*", sha1( $newPassword ) ) );

  if (!$user_get) {
    $message[] = "Errore E200 - Impossibile collegarsi al server, nessuna modifica effettuata. Contatta il tuo amministratore di sistema.";
    return false;
  }
  
  $auth_entry = ldap_first_entry($con, $user_search);
   
  $entry = array();
  $entry["userPassword"] = "$encoded_newPassword";
   
  if (ldap_modify($con,$user_dn,$entry) === false){
    $error = ldap_error($con);
    $errno = ldap_errno($con);
    $message[] = "Errore E201 - La tua password non può essere modificata, contatta il tuo amministratore di sistema.";
    $message[] = "$errno - $error";
  } else {
    $message_css = "yes";
    $message[] = "La password per l'utente $user_id è stata cambiata.<br/>La tua nuova password è già attiva.";
  }
}
 
?>
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">
    <title>FUSS Server Password Changer</title>

    <link href="css/bootstrap.min.css" rel="stylesheet">
    <script type="text/javascript" src="js/bootstrap.min.js"></script>
    <!-- Custom styles for this template -->
  </head>

  <body>

   <div class="container-fluid">
     <div class="col-md-4">
        <img class="center-block" src="logo.png">			
        <h2 class="form-signin-heading">Cambia password</h2>
	<p>Inserisci il tuo nome utente, la tua password attuale, e ripeti due volte la nuova password che vuoi adottare.</p>

       </div>
     <div class="col-md-8">
      <form class="form-signin" role="form" method="post" name="passwordChange" action="<?php print $_SERVER['PHP_SELF']; ?>">
	<?php
	   if (isset($_POST["submitted"])) {
           changePassword($_POST['username'],$_POST['oldPassword'],$_POST['newPassword1'],$_POST['newPassword2']);
           global $message_css;
           if ($message_css == "yes") {
           ?><div class="alert alert-success"><?php
				     } else {
						 ?><div class="alert alert-danger"><?php
										      $message[] = "Your password was not changed.";
							      }
							      foreach ( $message as $one ) { echo "<p>$one</p>"; }
							      ?></div><?php
      } ?>

	  <input name="username" class="form-control" placeholder="Nome utente" required autofocus type="text" size="20px" autocomplete="off" />

	  <input name="oldPassword" size="20px" type="password" placeholder="Password attuale" class="form-control" required/>

	  <input name="newPassword1" size="20px" type="password" placeholder="Nuova password" class="form-control" required/>

	  <input name="newPassword2" size="20px" type="password" placeholder="Ripeti nuova password" class="form-control" required/>

	  <input class="btn btn-success btn-lg btn-block" name="submitted" type="submit" value="Cambia password"/>
	  <button class="btn btn-danger btn-lg btn-block" onclick="$('frm').action='changepassword.php';$('frm').submit();">Annulla</button>

      </form>
</div>
    </div> <!-- /container -->

  </body>
</html>







